/******************************************************************************
* Copyright (C) 2008 - Ikaro Games   www.ikarogames.com                       *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                             *
*                                                                             *
*       generated by dia/DAOcodegen.py                                        *
*       Version: 1.11                                                          *
******************************************************************************/

#ifndef CDAOFACTORYSQLITE_H_
#define CDAOFACTORYSQLITE_H_

#include <sqlite3.h>
#include <string>

#include "../../../dao/factory/IDAOFactory.h"

#include "../../../dao/IPfGoalsDAO.h"
#include "../../../dao/IPfGameStatesDAO.h"
#include "../../../dao/IPfTeamsDAO.h"
#include "../../../dao/IPfMatchesDAO.h"
#include "../../../dao/IPfGameOptionsDAO.h"

#include "../CPfGoalsDAOSQLite.h"
#include "../CPfGameStatesDAOSQLite.h"
#include "../CPfTeamsDAOSQLite.h"
#include "../CPfMatchesDAOSQLite.h"
#include "../CPfGameOptionsDAOSQLite.h"

class CDAOFactorySQLite : public IDAOFactory
{
public:
    CDAOFactorySQLite(std::string file);
    virtual ~CDAOFactorySQLite();

    virtual bool createSchema();

    virtual bool beginTransaction();
    virtual bool commit();
    virtual bool rollback();

    virtual IPfGoalsDAO* getIPfGoalsDAO();
    virtual IPfGameStatesDAO* getIPfGameStatesDAO();
    virtual IPfTeamsDAO* getIPfTeamsDAO();
    virtual IPfMatchesDAO* getIPfMatchesDAO();
    virtual IPfGameOptionsDAO* getIPfGameOptionsDAO();


private:
    sqlite3 *m_database;

    CPfGoalsDAOSQLite *m_PfGoalsDAOSQLite;
    CPfGameStatesDAOSQLite *m_PfGameStatesDAOSQLite;
    CPfTeamsDAOSQLite *m_PfTeamsDAOSQLite;
    CPfMatchesDAOSQLite *m_PfMatchesDAOSQLite;
    CPfGameOptionsDAOSQLite *m_PfGameOptionsDAOSQLite;

};
#endif /*CDAOFACTORYSQLITE_H_*/
